hook global BufCreate .*\.ks %{
    set-option buffer filetype kickstart
}

add-highlighter shared/ regions -default code kickstart \
    comment '(^|\h)\K#' $ '' \
    double_string '"' (?<!\\)(\\\\)*" '' \
    single_string "'" (?<!\\)(\\\\)*' '' \
    packages '^\h*\K%packages\b' '^\h*\K%end\b' '' \
    shell '^\h*\K%(pre|pre-install|post)\b' '^\h*\K%end\b' ''

add-highlighter shared/kickstart/code regex "^\h*\b(auth|authconfig|autopart|autostep|bootloader|btrfs|clearpart|cmdline|device|dmraid|driverdisk|fcoe|firewall|firstboot|group|graphical|halt|ignoredisk|install|cdrom|harddrive|liveimg|nfs|url|iscsi|iscsiname|keyboard|lang|logvol|logging|mediacheck|monitor|multipath|network|part|partition|poweroff|raid|realm|reboot|repo|rescue|rootpw|selinux|services|shutdown|sshkey|sshpw|skipx|text|timezone|updates|upgrade|user|vnc|volgroup|xconfig|zerombr|zfcp)\b" 1:keyword
add-highlighter shared/kickstart/code regex '(--[\w-]+=? ?)([^-"\n][^\h\n]*)?' 1:attribute 2:string
add-highlighter shared/kickstart/code regex '%(include|ksappend)\b' 0:keyword

add-highlighter shared/kickstart/comment fill comment
add-highlighter shared/kickstart/single_string fill string
add-highlighter shared/kickstart/double_string fill string
add-highlighter shared/kickstart/packages regex "^\h*[\w-]*" 0:value
add-highlighter shared/kickstart/packages regex "#[^\n]*" 0:comment
add-highlighter shared/kickstart/packages regex "^\h*@\^?[\h\w-]*" 0:attribute
add-highlighter shared/kickstart/packages regex '\A\h*\K%packages\b' 0:type
add-highlighter shared/kickstart/packages regex '^\h*%end\b' 0:type
add-highlighter shared/kickstart/shell regex '\A\h*\K%(pre-install|pre|post)\b' 0:type
add-highlighter shared/kickstart/shell regex '^\h*%end\b' 0:type
add-highlighter shared/kickstart/shell ref sh


hook -group kickstart-highlight global WinSetOption filetype=kickstart %{ add-highlighter window ref kickstart }
hook -group kickstart-highlight global WinSetOption filetype=(?!kickstart).* %{ remove-highlighter window/kickstart }
